﻿Module Module1

    Private forms As New List(Of Form)
    
    Public Event WindowOpened(ByRef Source As Form)
    Public Event WindowClosed(ByRef Source As Form)

    Public ReadOnly Property AllForms() As Form()
        Get
            Return forms.ToArray()
        End Get
    End Property

    Public Sub onWindowOpened(ByRef Source As Form)
        forms.Add(Source)
        RaiseEvent WindowOpened(Source)
    End Sub

    Public Sub onWindowClosed(ByRef Source As Form)
        forms.Remove(Source)
        RaiseEvent WindowClosed(Source)
    End Sub

End Module
